<?php
/*******************************************************************************
 *	backup.php		Performs backup of site
 *				T.Barnaby,	BEAM Ltd,	2007-06-21
 *******************************************************************************
 */
require_once "../../config.php";

function dbOpen($host, $user, $password, $database){
	$db = mysql_connect($host, $user, $password)
		or trigger_error("Can't connect to the database server $host", E_USER_ERROR);
	mysql_select_db($database, $db)
	        or trigger_error("Can't access the database $this->state->databaseName: " . mysql_error() . " [#" . mysql_errno() . "]", E_USER_ERROR);
	return $db;
}

function dbClose($db){
	mysql_close($db);
}

function dbQuery($db, $cmd){
	$res = mysql_query($cmd, $db)
		or trigger_error('SQL Error: '.mysql_error(), E_USER_ERROR);

	return $res;
}

function dbQueryData($db, $cmd){
	$res = dbQuery($db, $cmd);
	
	$rows = array();
	while($row = mysql_fetch_array($res, MYSQL_ASSOC)){
		$rows[] = $row;
	}
	
	mysql_free_result($res);

	return $rows;
}

function dbDumpTables($host, $user, $password, $database, $tablePrefix, $withData = 0){
	$tables = array();
	$db = dbOpen($host, $user, $password, $database);
	
	$rows = dbQueryData($db, "show tables");
	foreach($rows as $row){
		$r = array_values($row);
//		print "Test: {$r[0]}\n";
		if(ereg("^$tablePrefix", $r[0])){
			$tables[] = $r[0];
		}
	}
	$tablesStr = implode(" ", $tables);
	
	$cmd = "mysqldump -h $host -u $user -p$password -c -C $database {$tablesStr}";
	if($withData)
		$cmd = "$cmd -t";
	else		
		$cmd = "$cmd -d";

	exec($cmd, $res);
	
	if(0){
		foreach($res as $line){
			print "$line\n";
		}
	}
	
	dbClose($db);
	return $res;
}

if(1){
	$file = fopen("tables.sql", "w");

	$res = dbDumpTables($state->databaseHost, $state->databaseUser, $state->databasePassword, $state->databaseName, $state->databasePrefix, 0);
	foreach($res as $line){
		fwrite($file, "$line\n");
	}
	fclose($file);
}

if(1){
	$file = fopen("data.sql", "w");

	$res = dbDumpTables($state->databaseHost, $state->databaseUser, $state->databasePassword, $state->databaseName, $state->databasePrefix, 1);
	foreach($res as $line){
		fwrite($file, "$line\n");
	}
	fclose($file);
}

if(1){
	$r = exec("tar -czf ../../dataBase/backup.tar.gz tables.sql data.sql", $res);
	printf("TarRes: {$r}<br>\n");
}

print("Dumped tables from Database: {$state->databaseName} TablePrefix: {$state->databasePrefix}\n");
?>
