<?php
/*******************************************************************************
 *	createTables.php	Create tables in database
 *				T.Barnaby,	BEAM Ltd,	2006-05-27
 *******************************************************************************
 */
require_once "../../config.php";

function dbOpen($host, $user, $password, $database){
	$db = mysql_connect($host, $user, $password)
		or trigger_error("Can't connect to the database server $host", E_USER_ERROR);
	mysql_select_db($database, $db)
	        or trigger_error("Can't access the database $this->state->databaseName: " . mysql_error() . " [#" . mysql_errno() . "]", E_USER_ERROR);
	return $db;
}

function dbClose($db){
	mysql_close($db);
}

function dbQuery($db, $cmd){
	$res = mysql_query($cmd, $db)
		or trigger_error('SQL Error: '.mysql_error(), E_USER_ERROR);

	return $res;
}

function dbQueryData($db, $cmd){
	$res = dbQuery($db, $cmd);
	
	$rows = array();
	while($row = mysql_fetch_array($res, MYSQL_ASSOC)){
		$rows[] = $row;
	}
	
	mysql_free_result($res);

	return $rows;
}

function tmp(){
	$rows = dbQueryData($db, "show tables");
	foreach($rows as $row){
		$r = array_values($row);
//		print "Test: {$r[0]}\n";
		if(ereg("^$tablePrefix", $r[0])){
			$tables[] = $r[0];
		}
	}
	$tablesStr = implode(" ", $tables);
	
	$cmd = "mysqldump -h $host -u $user -p$password -c -C -d $database {$tablesStr}";

	exec($cmd, $res);
	
	foreach($res as $line){
		print "$line\n";
	}
}
function createTables($host, $user, $password, $database, $fileName, $tablePrefix){
	$file = fopen($fileName, "r");

	$db = dbOpen($host, $user, $password, $database);
	
	$cmd = "";
	while($line = fgets($file)){
		$line = substr($line, 0, strlen($line) - 1);
//		print "DoLine: $line\n";
		if(strlen($line) == 0)
			continue;
		if(($line[0] == '/') or ($line[0] == '-'))
			continue;
		
		if($line[strlen($line) - 1] == ';'){
			$cmd = "$cmd $line";
//			print "Execute: $cmd\n";
			dbQuery($db, $cmd);
			$cmd = "";
			continue;
		}
		if(ereg("^CREATE TABLE", $line)){
			$l = explode(" ", $line);
			$tn = substr($l[2], 1, strlen($l[2]) - 2);
			$l[2] = "`$tablePrefix$tn`";
			$line = implode(" ", $l);
//			print "CreateTable: $line\n";
		}
//		print "CheckLine: $line\n";
		if(ereg("^DROP TABLE", $line)){
			$l = explode(" ", $line);
			$tn = substr($l[4], 1, strlen($l[4]) - 2);
			$l[4] = "`$tablePrefix$tn`";
			$line = implode(" ", $l);
			print "DropTable: $line\n";
		}
		$cmd = "$cmd $line";
	}
	
	dbClose($db);
	fclose($file);
}

//$res = createTables($state->databaseHost, $state->databaseUser, $state->databasePassword, $state->databaseName, "tables.sql", $state->databasePrefix);
$res = createTables($state->databaseHost, $state->databaseUser, $state->databasePassword, $state->databaseName, "tables.sql", "");
print "Tables Created";
?>
