<?php
/*******************************************************************************
 *	DocumentToContent.php	Converts the document database to a content one
 *				T.Barnaby,	BEAM Ltd,	2008-03-16
 *******************************************************************************
 */
//$_SERVER["HTTP_HOST"] = "king.kingnet";

require_once "../../config.php";

function dbEscapeString($str){
	return mysql_real_escape_string($str);
}

function dbOpen($host, $user, $password, $database){
	$db = mysql_connect($host, $user, $password)
		or trigger_error("Can't connect to the database server $host", E_USER_ERROR);
	mysql_select_db($database, $db)
	        or trigger_error("Can't access the database $this->state->databaseName: " . mysql_error() . " [#" . mysql_errno() . "]", E_USER_ERROR);
	return $db;
}

function dbClose($db){
	mysql_close($db);
}

function dbQuery($db, $cmd){
	$res = mysql_query($cmd, $db)
		or trigger_error('SQL Error: '.mysql_error(), E_USER_ERROR);

	return $res;
}

function dbQueryData($db, $cmd){
	$res = dbQuery($db, $cmd);
	
	$rows = array();
	while($row = mysql_fetch_array($res, MYSQL_ASSOC)){
		$rows[] = $row;
	}
	
	mysql_free_result($res);

	return $rows;
}

function dbQueryObjects($db, $cmd){
	$res = dbQuery($db, $cmd);
	
	$rows = array();
	while($row = mysql_fetch_object($res)){
		$rows[] = $row;
	}
	
	mysql_free_result($res);

	return $rows;
}

function dbAppendObject($db, $table, $obj){
	$s = "";
	foreach($obj as $k => $v){
		$v = dbEscapeString($v);
		if($k != "idxxxxx"){
			if(strlen($s))
				$s = "$s, ";
			$s = "$s`$k`='$v'";  
		}
	}
	$sqlCmd = "insert into $table set $s";

	mysql_query($sqlCmd, $db)
		or trigger_error('SQL Error: '.mysql_error(), E_USER_ERROR);

	// Get Object id
	$sqlCmd = "select id from $table order by id desc limit 1";
	$res = mysql_query($sqlCmd, $db)
		or trigger_error('SQL Error: '.mysql_error(), E_USER_ERROR);

	$o = mysql_fetch_object($res);
	mysql_free_result($res);

	$obj->id = $o->id;

	return $obj;
}


function documentToContent($host, $user, $password, $database, $tablePrefix){
	$db = dbOpen($host, $user, $password, $database);
	
	// Delete all entries in table
	dbQuery($db, "truncate table {$tablePrefix}Content");

	$list = dbQueryObjects($db, "select * from {$tablePrefix}Document");
	foreach($list as $obj){
		print_r($obj);
		
		$newObj->id = $obj->id;
		$newObj->type = "doc";
		$newObj->title = $obj->title;
		$newObj->category = $obj->category;
		$newObj->description = $obj->description;
		$newObj->version = $obj->version;
		$newObj->dateCreated = $obj->dateAdded;
		$newObj->dateModified = $obj->dateAdded;
		$newObj->content = "";
		$newObj->filePath = "documents/document";
		$newObj->fileNameOriginal = "";
		$newObj->uid = 0;
		$newObj->access = "";

		dbAppendObject($db, "{$tablePrefix}Content", $newObj);
	}

	dbClose($db);
}

print "Start Database Conversion";
documentToContent($state->databaseHost, $state->databaseUser, $state->databasePassword, $state->databaseName, $state->databasePrefix);
print "Converted";

?>




?>
