<?php
/*******************************************************************************
 *	BModule.php		Module interface
 *				T.Barnaby,	BEAM Ltd,	2008-01-04
 *******************************************************************************
 */

class BModule {
	// Basic Interface routines
	function BModule(){
		$this->name = "module";
		$this->title = "Module";
		$this->info = "Default Module";
	}
	
	function name(){
		return $this->name;
	}
	
	function title(){
		return $this->title;
	}
	
	function info(){
		return $this->info;
	}
	
	// Standard interface
	function checkAccess(){
		return 1;
	}

	function getMenu(){
		return null;
	}
	function getPage($uri){
		return "<H1>Module Default Page</H1>";
	}
	function getPageBlock($uri){
		$o = new BBlock();
		$o->title = "Module Block";
		$o->content ="Module Block< Contents>";
		return $o;
	}
	
	// Admin interface
	function getAdminMenu(){
		return null;
	}
	function getAdminPage($uri){
		return "<H1>Module Default Admin Page</H1>";
	}
	function getAdminPageBlock($uri){
		$o = new BBlock();
		$o->title = "Module Admin Block";
		$o->content ="Module Admin Block Contents";
		return $o;
	}
	
	var	$name;
	var	$info;
}

?>
