<?php

require_once "lib/BState.php";

/*
 * PHP settings:
 *
 * To see what PHP settings are possible, including whether they can
 * be set at runtime (ie., when ini_set() occurs), read the PHP
 * documentation at http://www.php.net/manual/en/ini.php#ini.list
 * and take a look at the .htaccess file to see which non-runtime
 * settings are used there. Settings defined here should not be
 * duplicated there so as to avoid conflict issues.
 */
if(0){
ini_set('arg_separator.output',     '&amp;');
ini_set('magic_quotes_runtime',     0);
ini_set('magic_quotes_sybase',      0);
ini_set('session.cache_expire',     200000);
ini_set('session.cache_limiter',    'none');
ini_set('session.cookie_lifetime',  2000000);
ini_set('session.gc_maxlifetime',   200000);
// ini_set('session.save_handler',     'user');
// ini_set('session.use_only_cookies', 1);
// ini_set('session.use_trans_sid',    0);
ini_set('url_rewriter.tags',        '');
}

// Configuration information for project
if(!isset($_SERVER["HTTP_HOST"])){
	$_SERVER["HTTP_HOST"] = "localhost";
}

$state = new BState;

$state->init();

$state->databaseHost		= "beam.beamnet";
$state->databaseName		= "greenpower";
$state->databaseUser		= "greenpower";
$state->databasePassword	= "greenpower";
$state->databasePrefix		= "greenpower_";
$state->siteName		= "greenpower";
$state->siteTitle		= "Greenpower";
$state->siteEmailAddress	= "terry@beam.ltd.uk";
$state->modules			= array("user", "forum", "showcase", "document", "category", "statistics");
$state->style			= "greenpower";
$state->logo			= "greenpowerLogo.gif";
$state->title			= "Greenpower";
$state->loginRequired		= 0;
$state->emailSend		= 0;			// Enable/disable the sending of emails
$state->moto			= "";

if(1){
if($_SERVER["HTTP_HOST"] == "beam.beamnet"){
	$state->baseDir			= "/src/greenpower/www";
	$state->baseUrl			= "http://beam.beamnet/src/greenpower/www";
}
else if($_SERVER["HTTP_HOST"] == "portal.beam.ltd.uk"){
	$state->baseDir			= "/var/www/greenpower";
	$state->baseUrl			= "http://portal.beam.ltd.uk/greenpower";
}
}
//$state->baseDir			= "/data/src/greenpower/www";
//$state->baseUrl			= "http://king.kingnet/data/src/greenpower/www";

// Set include paths
set_include_path($state->baseDir . '/lib' . PATH_SEPARATOR . get_include_path());
set_include_path($state->baseDir . '/lib/Smarty-2.6.13/libs' . PATH_SEPARATOR . get_include_path());
set_include_path($state->baseDir . '/lib/pear/php' . PATH_SEPARATOR . get_include_path());
set_include_path($state->baseDir . '/modules' . PATH_SEPARATOR . get_include_path());

?>
